/*
2017-2018 Aron Barath

This file has been put into the public domain.
You can do whatever you want with this file.
*/

#ifndef PTRARR_H
#define PTRARR_H

#include <stddef.h>

struct ptrarr
{
	void** pointers;
	size_t size;
	size_t capacity;
};

/* these functions will call abort() on memory shortage */

void ptrarr_init(struct ptrarr* const arr);
void ptrarr_deinit(struct ptrarr* const arr);
void ptrarr_add(struct ptrarr* const arr, void* const ptr);
void ptrarr_remove(struct ptrarr* const arr, size_t index);

#endif /* PTRARR_H */
